'***********************************************************
'
' Read and Print a CSV file
'
' Author     : Larry Belmontes, Jr.
' Description: Script to read CSV formatted file, decode 
'              delimited columns via Regular Expressions,
'              and print each delimited data element to a
'			   text file.
' Languages  : VBScript
' File Name  : CSV-RegExp.vbs
' Disclaimer: This software is intended for educational learning
'             and illustrative purposes.
'
'             This software is provided "AS IS" and without any
'             expressed or implied warranties, including, without
'             limitation, the implied warranties of merchantability
'             and fitness for a particular purpose.
'
'             No guarantee; No warranty; Install / Use at your own risk.
'
'
' Copyright (C) 2015 Larry Belmontes, Jr. 
'
'
'
'***********************************************************
'
' All variables must be defined
Option Explicit
'
' Define variables in script
Dim objFSO, objTextFile, objLOGout, objReg
Dim arrStr, rcdCnt, CSVfileIN, LOGfileOUT
Dim logContent, sLine, x
'
' Instantiate Regular Expression object
'   Ignore case and inspect entire string
'   using this pattern ,(?=[^"]*"[^"]*(?:"[^"]*"[^"]*)*$)
Set objReg=CreateObject("vbscript.regexp")
objReg.IgnoreCase = True
objReg.Global = True
objReg.Pattern=",(?=[^" & chr(34) & "]*" & chr(34) & "[^" & chr(34) & "]*(?:" & chr(34) & "[^" & chr(34) & "]*" & chr(34) & "[^" & chr(34) & "]*)*$)"
'
' Declare filenames
CSVfileIN = "C:\CSV-Demo\CSV-comma-data.txt"
LOGfileOUT = "C:\CSV-Demo\CSV-comma-log.txt"
'
' Instantiate File System, CSV input and Log output objects
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objTextFile = objFSO.OpenTextFile(CSVfileIN)	
Set objLOGout = objFSO.CreateTextFile(LOGfileOUT,2)
'
' Capture LOG data into string logContent
logContent = ""
logContent = logContent + "--------------------------------------------------------------------------" + vbCrLf
'
' Read each record in CSV input file until end of file
Do While NOT objTextFile.AtEndOfStream
	rcdCnt = rcdCnt + 1
	sLine = objTextFile.ReadLine
	logContent = logContent + "** Record #" + Cstr(rcdCnt) + "    (raw data):" + sLine + vbCrLf
	'change comma to unique set of characters within double quotes
	sLine = objReg.Replace(sLine,"@@")
	logContent = logContent + "** Record #" + Cstr(rcdCnt) + " (after Regex):" + sLine + vbCrLf
	'extract all values delimited by comma into array arrStr
	arrStr = split(sLine,",")
	'print each element in array arrStr
	For x = 0 to Ubound(arrStr)
		logContent = logContent + "** Value " + Right("0" & Cstr(x+1), 2) + ": " + arrStr(x)  + vbCrLf
		'restore unique set of characters to comma
		arrStr(x) = Replace(arrStr(x),"@@",",")
		logContent = logContent + "**    after: " + arrStr(x) + vbCrLf
	Next
	logContent = logContent + vbCrLf
Loop
'
' Last LOG entry
logContent = logContent + "--------------------------------------------------------------------------" + vbCrLf
logContent = logContent + vbCrLf
'
' Write data to LOG file
objLOGout.Write logContent 
'
' Close files
objLOGout.Close
objTextFile.Close
'
' Release Objects
Set objTextFile = Nothing
Set objLOGout = Nothing
Set objFSO = Nothing
Set objReg = Nothing

